<?php
/*
Plugin Name: Google Analytics Popular Posts
Plugin URI: http://wordpress.org/extend/plugins/google-analytics-popular-posts/
Description: This plugin uses Google Analytics API to fetch data from your analytics account and displays popular posts in the widget.
Version: 1.0.9
Author: koichiyaima
Author URI: http://yaima.sakuraweb.com/
*/
/*  Copyright 2011 Yaima surf (email : yaima-surf@yaima.sakuraweb.com)

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public Licen se as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
*/

/**
 * GoogleAnalyticsPopularPosts Class
 */
class GoogleAnalyticsPopularPosts extends WP_Widget {

	// Constructor
	function GoogleAnalyticsPopularPosts() {
		$GAPP_url = get_bloginfo('siteurl');
		$lang = dirname( plugin_basename( __FILE__ ) ) . "/languages";
		load_plugin_textdomain( 'google-analytics-popular-posts', false, $lang );
		$widget_ops = array( 'description' => __('This plugin uses Google Analytics API to fetch data from your analytics account and displays popular posts in the widget.', 'google-analytics-popular-posts') );
		$control_ops = array('width' => 400, 'height' => 350);
		parent::WP_Widget(false, $name = __('Google Analytics Popular Posts', 'google-analytics-popular-posts'),$widget_ops, $control_ops);
	}

	// WP_Widget::form
	function form($instance) {
		$title = strip_tags($instance['title']);
		$GAPP_usr = esc_attr($instance['GoogleAnalyticsPopularPosts_username']);
		$GAPP_pwd = esc_attr($instance['GoogleAnalyticsPopularPosts_password']);
		$GAPP_pID = esc_attr($instance['GoogleAnalyticsPopularPosts_profileID']);
		$GAPP_mRs = esc_attr($instance['GoogleAnalyticsPopularPosts_maxResults']);
		$GAPP_aSDs = esc_attr($instance['GoogleAnalyticsPopularPosts_statsSinceDays']);
		$GAPP_filter = esc_attr($instance['GoogleAnalyticsPopularPosts_filter']);
		?>

<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('<b>Title:</b>', 'google-analytics-popular-posts'); ?></label>
		<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></p>
		<p><label for="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_username'); ?>"><?php _e('<b>Google Account Email:</b><br />Please fill the email address you use to login to your Google Analytics.', 'google-analytics-popular-posts'); ?> <input class="widefat" id="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_username'); ?>" name="<?php echo $this->get_field_name('GoogleAnalyticsPopularPosts_username'); ?>" type="text" value="<?php echo $GAPP_usr; ?>" /></label></p>
		<p><label for="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_password'); ?>"><?php _e('<b>Google Account Password:</b><br />Please fill password correct too again.', 'google-analytics-popular-posts'); ?> <input class="widefat" id="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_password'); ?>" name="<?php echo $this->get_field_name('GoogleAnalyticsPopularPosts_password'); ?>" type="password" value="<?php echo $GAPP_pwd; ?>" /></label></p>
		<p><label for="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_profileID'); ?>"><?php _e('<b>Google Analytics Profile ID:</b><br />Check for your Profile ID. <br />(UA-xxxxxxx-xx is not the Profile ID, The profile ID of your account can be found in the URL of your reports.<br />For example, if you select a profile from an account and view your reports, you may see a URL string that looks like this:<br />https://www.google.com/analytics/reporting/?reset=1&id=123456&pdr=00000000-00000000<br />The profile ID is the number that comes right after the &id parameter. So, in this case, your profile ID would be 123456.)', 'google-analytics-popular-posts'); ?> <input class="widefat" id="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_profileID'); ?>" name="<?php echo $this->get_field_name('GoogleAnalyticsPopularPosts_profileID'); ?>" type="text" value="<?php echo $GAPP_pID; ?>" /></label></p>
		<p><label for="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_maxResults'); ?>"><?php _e('<b>Popular Posts Max Results:</b><br />Example: 10 or 15 or 20 etc.', 'google-analytics-popular-posts'); ?> <input class="small-text" id="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_maxResults'); ?>" name="<?php echo $this->get_field_name('GoogleAnalyticsPopularPosts_maxResults'); ?>" type="text" value="<?php echo $GAPP_mRs; ?>" /></label></p>
		<p><label for="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_statsSinceDays'); ?>"><?php _e('<b>Stats Since Days:</b><br />Define the number of days you want the analytics Popular Posts for, Example: 7 or 30 or 90 etc.', 'google-analytics-popular-posts'); ?> <input class="small-text" id="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_statsSinceDays'); ?>" name="<?php echo $this->get_field_name('GoogleAnalyticsPopularPosts_statsSinceDays'); ?>" type="text" value="<?php echo $GAPP_aSDs; ?>" /><?php _e('Days', 'google-analytics-popular-posts'); ?></label></p>
		<p><label for="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_filter'); ?>"><?php _e('<b>GAPI Filter:</b>If home page and other pages do not get, only get the permalink blog begins, just typing blog.<br />Example: blog', 'google-analytics-popular-posts'); ?> <input class="widefat" id="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_filter'); ?>" name="<?php echo $this->get_field_name('GoogleAnalyticsPopularPosts_filter'); ?>" type="text" value="<?php echo $GAPP_filter; ?>" /></label></p>
		<p><?php _e('Thank you for using this plugin! I hope you enjoy it!<br />Author: <a href="http://yaima.sakuraweb.com" target="_blank">http://yaima.sakuraweb.com</a>', 'google-analytics-popular-posts'); ?></p>
		<?php
	}

	// WP_Widget::update
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
	
	// WP_Widget::widget
	function widget( $args, $instance ) {
		extract($args);
		$title = apply_filters('widget_title', empty($instance['title']) ? '' : $instance['title']);
		$GAPP_usr = apply_filters('widget_title', empty($instance['GoogleAnalyticsPopularPosts_username']) ? '' : $instance['GoogleAnalyticsPopularPosts_username']);
		$GAPP_pwd = apply_filters('widget_title', empty($instance['GoogleAnalyticsPopularPosts_password']) ? '' : $instance['GoogleAnalyticsPopularPosts_password']);
		$GAPP_pID = apply_filters('widget_title', empty($instance['GoogleAnalyticsPopularPosts_profileID']) ? '' : $instance['GoogleAnalyticsPopularPosts_profileID']);
		$GAPP_mRs = apply_filters('widget_title', empty($instance['GoogleAnalyticsPopularPosts_maxResults']) ? '' : $instance['GoogleAnalyticsPopularPosts_maxResults']);
		$GAPP_aSDs = apply_filters('widget_title', empty($instance['GoogleAnalyticsPopularPosts_statsSinceDays']) ? '' : $instance['GoogleAnalyticsPopularPosts_statsSinceDays']);
		$GAPP_filter = apply_filters('widget_title', empty($instance['GoogleAnalyticsPopularPosts_filter']) ? '' : $instance['GoogleAnalyticsPopularPosts_filter']);
		echo $before_widget;
		if ( !empty( $title ) ) {
			echo $before_title . $title . $after_title;
		}
		if(is_numeric($GAPP_aSDs)) {
			$todays_year = date("Y");
			$todays_month = date("m");
			$todays_day = date("d");
			$date = "$todays_year-$todays_month-$todays_day";
			$newdate = strtotime ( "-$GAPP_aSDs day" , strtotime ( $date ) ) ;
			$newdate = date ( 'Y-m-d' , $newdate );
			$From = $newdate;
		}

		define('ga_email', $GAPP_usr);
		define('ga_password', $GAPP_pwd);
		define('ga_profile_id', $GAPP_pID);

		// 1.0.8
		$str = $GAPP_filter;
		$pattern = 'ga:pagePath=~\^\/';
		$replace = '';
		$GAPP_filter_replaced = ereg_replace($pattern, $replace, $str);
		$GAPP_filter_fixed = 'ga:pagePath=~^/';

		require 'gapi.class.php';
		include_once(ABSPATH . WPINC . '/feed.php');

		$ga = new gapi(ga_email, ga_password);
		$ga->requestReportData(ga_profile_id, array('hostname', 'pagePath'), array('visits'), array('-visits'), $filter=$GAPP_filter_fixed.$GAPP_filter_replaced, $start_date=$From, $end_date=$date, $start_index=1, $max_results=$GAPP_mRs);
		?>
		
		<li id="popular_post">
			<p class="popular_date"><?php echo $From ?> ～ <?php echo $date ?></p>

			<?php
				foreach($ga->getResults() as $result):
					//1.0.9
					$getHostname = $result->getHostname();
					$getPagepath = $result->getPagepath();
					$postPagepath = 'http://'.$getHostname.$getPagepath;
					$getPostID = url_to_postid($postPagepath);

					if ($getPostID <= 0) {
						$titleStr = $postPagepath;
						}
					else {
						$titleStr = get_the_title($getPostID);
						}
			?>

<div class="popular_post"><a href='<?php echo $postPagepath ?>'><?php echo $titleStr ?></a></div>

			<?php
				endforeach
			?>
		</li>

		<?php
		echo $after_widget;
		}


} // class GoogleAnalyticsPopularPosts


function loadCSS()
    {
        $style = get_template_directory().'/google-analytics-popular-posts.css';
        if (is_file($style)) {
            $style = get_bloginfo('stylesheet_directory').'/google-analytics-popular-posts.css';
        } else {
            $url = WP_PLUGIN_URL.'/'.dirname(plugin_basename(__FILE__));
            $style = $url.'/google-analytics-popular-posts.css';
        }
        echo "<!--Google Analytics Popular Posts plugin-->\n";
        echo '<link rel="stylesheet" type="text/css" media="all" href="'.$style.'">';
    }

add_action(
    'wp_head',
    'loadCSS'
);

// register Google Analytics Popular Posts widget
function GoogleAnalyticsPopularPostsInit() {
    register_widget('GoogleAnalyticsPopularPosts');
}

add_action('widgets_init', 'GoogleAnalyticsPopularPostsInit');
?>